﻿@page "/"
@using StackExchange.Redis
@using DemoLatency.Code


<RadzenTextBox 
    Disabled="@(Redis is not null)"
    @ref="@ConnectText"
    TValue="string" />

<RadzenButton 
    Disabled="@(Redis is not null)"
    Click="@OnConnectClick" 
    Text="Connect"/>

<RadzenButton 
    Disabled="@(Redis is null)"
    Click="@OnSendClick" 
    Text="Send"/>


@foreach (var message in Messages)
{
    <div>@message.Id.ToString("0000") - @(message.Received - message.Sent)</div>
}

@code 
{
    RadzenTextBox ConnectText { get; set; } = null!;

    ConnectionMultiplexer? Redis { get; set; }

    List<MessageData> Messages { get; } = new();


    void OnConnectClick()
    {
        Redis?.Close();
        Unsubscribe();
        Redis = ConnectionMultiplexer.Connect(ConnectText.Value);
        Subscribe();
    }

    void Subscribe()
    {
        Redis?.GetSubscriber().Subscribe(Utils.ChannelForwardName, OnReceiveForward);
        Redis?.GetSubscriber().Subscribe(Utils.ChannelBackName, OnReceiveBack);
    }

    void Unsubscribe()
    {
        Redis?.GetSubscriber().Unsubscribe(Utils.ChannelForwardName, OnReceiveForward);
        Redis?.GetSubscriber().Unsubscribe(Utils.ChannelBackName, OnReceiveBack);
    }

    void OnSendClick()
    {
        var next = (Messages.MaxBy(m => m.Id)?.Id ?? -1) + 1;
        var ts = DateTimeOffset.Now.ToUnixTimeMilliseconds();
        Redis?.GetSubscriber().Publish(Utils.ChannelForwardName, next);
        
        lock (Messages)
        {
            Messages.Insert(0, new MessageData(next, ts));
        }
    }

    void OnReceiveForward(RedisChannel channel, RedisValue value)
    {
        Redis?.GetSubscriber().Publish(Utils.ChannelBackName, value);
    }

    void OnReceiveBack(RedisChannel channel, RedisValue value)
    {
        var id = (long)value;
        var ts = DateTimeOffset.Now.ToUnixTimeMilliseconds();
        lock (Messages)
        {
            Messages.FirstOrDefault(m => m.Id == id)!.Received = ts;
        }
        InvokeAsync(StateHasChanged);
    }
}